module DTK::State
  class Component::Attribute::Influxdb
    class Measurement
      class Errors < self

        def write(value, params_hash = {}, timestamp)
          checked_params_hash = check_params_hash(params_hash)
          write_point(value, checked_params_hash, timestamp)
        end

        def get_correlator_type(entrypoint)
          {
            correlator_type: entrypoint.split('/').last.split('.')[0]
          }
        end

        protected

        def required_params
          %i[namespace component_name assembly_name task_id attribute_name correlator_type]
        end
      end
    end
  end
end
