module DTK::State
  class Component::Attribute::Influxdb
    class Measurement
      class Events < self

        def write(value, params_hash = {}, timestamp)
          checked_params_hash = check_params_hash(params_hash)
          write_point(value, checked_params_hash, timestamp)
        end

        def get_required_tags(event_id, pod_name, pod_namespace, component_name, attribute_name, task_id)
          {
            event_id: event_id,
            pod_name: pod_name,
            pod_namespace: pod_namespace,
            component_name: component_name,
            attribute_name: attribute_name,
            task_id: task_id
          }
        end

        protected

        def required_params
          %i[event_id pod_name pod_namespace component_name attribute_name task_id]
        end
      end
    end
  end
end
