module DTK::State
  class Component::Attribute::Influxdb
    class Measurement
      class States < self

        def write(value, params_hash = {}, timestamp)
          checked_params_hash = check_params_hash(params_hash)
          write_point(value, checked_params_hash, timestamp)
        end

        def get_required_tags(type, name, namespace, object_state, component_name, attribute_name, task_id)
          {
            type: type,
            name: name,
            namespace: namespace,
            object_state: object_state,
            component_name: component_name,
            attribute_name: attribute_name,
            task_id: task_id
          }
        end

        protected

        def required_params
          %i[type name namespace object_state component_name attribute_name task_id]
        end
      end
    end
  end
end
