module DTK::State
  class ComponentDef
    require_relative 'component_def/attribute_type_info'

    COMPONENT_DEF_CRD_VERSION     = ENV["COMPONENT_DEF_CRD_VERSION"]

    attr_reader :name, :namespace, :executable_actions, :attribute_type_info

    def initialize(namespace, name, content)
      @name                = name
      @namespace           = namespace
      @executable_actions  = content[:spec][:actions] || {}
      @attribute_type_info  = AttributeTypeInfo.create_from_kube_hash(content[:spec][:attributes] || {})
    end

    def self.get(namespace, name, opts = {})
      opts[:apiVersion] = COMPONENT_DEF_CRD_VERSION
      crd_component_def = ::DTK::CrdClient.get_kubeclient(opts).get_componentdef(name, namespace)
      ComponentDef.new(namespace, name, crd_component_def)
    end
  end
end