module DTK::State
  class ComponentDef
    class AttributeTypeInfo

      attr_reader :name, :type, :required, :dynamic, :encrypted, :temporal

      def initialize(name, params)
        @name      = name.to_s
        @type      = params[:type]
        @required  = params[:required]  || false
        @dynamic   = params[:dynamic]   || false
        @temporal  = params[:temporal]  || false
        @encrypted = params[:encrypted] || false
      end

      def self.create_from_kube_hash(kube_attributes)
        kube_attributes.to_hash.map do |attribute_name, attribute_content|
          AttributeTypeInfo.new(attribute_name, attribute_content)
        end
      end

      def to_hash
        type_info = {}

        type_info.merge!(name: @name) if @name
        type_info.merge!(type: @type) if @type
        type_info.merge!(required: @required) if @required
        type_info.merge!(dynamic: @dynamic) if @dynamic
        type_info.merge!(temporal: @temporal) if @temporal
        type_info.merge!(encrypted: @encrypted) if @encrypted

        type_info
      end

    end
  end
end