module DTK::State
  class ExecutableAction
    class AttributeTypeInfo

      attr_reader :name, :type, :required, :dynamic, :encrypted, :temporal

      def initialize(name, params)
        @name      = name.to_s
        @type      = params[:type]
        @required  = params[:required]  || false
        @dynamic   = params[:dynamic]   || false
        @temporal  = params[:temporal]  || false
        @encrypted = params[:encrypted] || false
      end

      def self.create_from_kube_hash(kube_attributes)
        kube_attributes.to_hash.map do |attribute_name, attribute_content|
          AttributeTypeInfo.new(attribute_name, attribute_content)
        end
      end

    end
  end
end