module DTK::State
  class Workflow
    require_relative 'workflow_instance/attribute_type_info'

    WORKFLOW_CRD_VERSION = ENV["WORKFLOW_CRD_VERSION"]

    attr_reader :name, :namespace, :references, :assembly, :workflow, :attribute_type_info

    def initialize(namespace, name, crd_content)
      @name      = name
      @namespace = namespace

      @references = crd_content.references
      @assembly   = @references.assembly
      @workflow   = crd_content.spec.workflow || {}

      @attribute_type_info = ::DTK::State::WorkflowInstance::AttributeTypeInfo.create_from_kube_hash(crd_content.spec.attributes.to_h || {})
    end

    def self.get(namespace, name, opts = {})
      opts[:apiVersion] = WORKFLOW_CRD_VERSION
      workflow = ::DTK::CrdClient.get_kubeclient(opts).get_workflow(name, namespace)
      Workflow.new(namespace, name, workflow)
    end
  end
end