module DTK::Utils
  module Log
    require 'logger'

    def self.instance
      @instance ||= Logger.new('/proc/1/fd/1', formatter: proc { |severity, datetime, progname, msg| 
        orange_color = "\x1b[33m"
        white_color = "\x1b[37m"
        red_color = "\x1b[31m"

        date_format = datetime.strftime("%Y-%m-%d %H:%M:%S:%L")
        if severity == "INFO"
          "#{orange_color}[#{date_format}] - #{white_color}#{msg}\n"
        elsif severity == "WARN"
          "#{orange_color}[#{date_format}] [WARNING] - #{msg}\n"
        elsif severity == "ERROR"       
            "#{red_color}[#{date_format}] [ERROR] - #{msg}\n"
        end
      })
    end 
  end
end